OpenTTD: NWidgetBackground Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Private Attributes
NWidgetBackground Class Reference
Hierarchical widgets

Nested widget with a child. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetBackground:

## Public Member Functions
| NWidgetBackground (WidgetType tp, Colours colour, int index, NWidgetPIPContainer *child=NULL)
| Constructor parent nested widgets.
void | Add (NWidgetBase *nwid)
| Add a child to the parent.
void | SetPIP (uint8 pip_pre, uint8 pip_inter, uint8 pip_post)
| Set additional pre/inter/post space for the background widget.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
void | FillNestedArray (NWidgetBase **array, uint length)
void | Draw (const Window *w)
| Draw the widgets of the tree.
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
Public Member Functions inherited from NWidgetCore
| NWidgetCore (WidgetType tp, Colours colour, uint fill_x, uint fill_y, uint32 widget_data, StringID tool_tip)
| Initialization of a 'real' widget.
void | SetIndex (int index)
| Set index of the nested widget in the widget array.
void | SetDataTip (uint32 widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget.
void | SetLowered (bool lowered)
| Lower or raise the widget.
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget.
bool | IsDisabled () const
| Return whether the widget is disabled.
bool | IsHighlighted () const
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour)
| Highlight the widget or not.
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets.
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget.
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget.
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size.
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Private Attributes
NWidgetPIPContainer * | child
| Child widget.

## Additional Inherited Members
Data Fields inherited from NWidgetCore
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
int | index
| Index of the nested widget in the widget array of the window (`-1` means 'not used').
uint32 | widget_data
| Data of the widget.
StringID | tool_tip
| Tooltip of the widget.
int | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Nested widget with a child.

Definition at line 545 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetBackground::NWidgetBackground | ( | WidgetType | tp,
|  | Colours | colour,
|  | int | index,
|  | NWidgetPIPContainer * | child = `NULL`
| ) |  |

Constructor parent nested widgets.

Parameters

  tp | Type of parent widget.
  colour | Colour of the parent widget.
  index | Index in the widget array used by the window system.
  child | Child container widget (if supplied). If not supplied, a vertical container will be inserted while adding the first child widget.

Definition at line 1712 of file widget.cpp.

References child, NWidgetCore::SetIndex(), WWT_FRAME, WWT_INSET, and WWT_PANEL.

## Member Function Documentation

void NWidgetBackground::Add | ( | NWidgetBase * | nwid | ) |

Add a child to the parent.

Parameters

  nwid | Nested widget to add to the background widget.

Unless a child container has been given in the constructor, a parent behaves as a vertical container. You can add several children to it, and they are put underneath each other.

Definition at line 1731 of file widget.cpp.

References NWidgetContainer::Add(), and child.

Referenced by MakeWidgetTree().

void NWidgetBackground::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| virtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Reimplemented from NWidgetResizeBase.

Definition at line 1811 of file widget.cpp.

References NWidgetBase::AssignSizePosition(), child, NWidgetBase::padding_bottom, NWidgetBase::padding_left, NWidgetBase::padding_right, NWidgetBase::padding_top, and NWidgetBase::StoreSizePosition().

void NWidgetBackground::Draw | ( | const Window * | w | ) |
| virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1829 of file widget.cpp.

References _colour_gradient, child, NWidgetCore::colour, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetPIPContainer::Draw(), DrawFrame(), DrawFrameRect(), DrawInset(), Window::DrawWidget(), FILLRECT_CHECKER, FR_LOWERED, GfxFillRect(), NWidgetCore::index, NWidgetCore::IsDisabled(), NWidgetBase::pos_x, NWidgetBase::pos_y, Window::SetStringParameters(), NWidgetBase::type, NWidgetCore::widget_data, WWT_FRAME, WWT_INSET, and WWT_PANEL.

NWidgetCore * NWidgetBackground::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Reimplemented from NWidgetCore.

Definition at line 1870 of file widget.cpp.

References child, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetPIPContainer::GetWidgetFromPos(), IsInsideBS(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

NWidgetBase * NWidgetBackground::GetWidgetOfType | ( | WidgetType | tp | ) |
| virtual

Retrieve a widget by its type.

Parameters

  tp | Widget type to search for.

Returns
  Returns the first widget of the specified type, or `NULL` if no widget can be found.

Reimplemented from NWidgetBase.

Definition at line 1880 of file widget.cpp.

References child, NWidgetContainer::GetWidgetOfType(), and NWidgetBase::type.

void NWidgetBackground::SetPIP | ( | uint8 | pip_pre,
|  | uint8 | pip_inter,
|  | uint8 | pip_post
| ) |  |

Set additional pre/inter/post space for the background widget.

Parameters

  pip_pre | Additional space in front of the first child widget (above for the vertical container, at the left for the horizontal container).
  pip_inter | Additional space between two child widgets.
  pip_post | Additional space after the last child widget (below for the vertical container, at the right for the horizontal container).

Note
  Using this function implies that the widget has (or will have) child widgets.

Definition at line 1749 of file widget.cpp.

References child, and NWidgetPIPContainer::SetPIP().

Referenced by MakeNWidget().

void NWidgetBackground::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1757 of file widget.cpp.

References child, NWidgetBase::fill_x, NWidgetBase::fill_y, FONT_HEIGHT_NORMAL, GetStringBoundingBox(), NWidgetCore::index, max(), maxdim(), NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, Window::nested_array, Window::nested_array_size, NWidgetBase::padding_bottom, NWidgetBase::padding_left, NWidgetBase::padding_right, NWidgetBase::padding_top, NWidgetBase::resize_x, NWidgetBase::resize_y, Window::SetStringParameters(), NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, NWidgetBase::type, Window::UpdateWidgetSize(), WD_FRAMERECT_RIGHT, WD_FRAMETEXT_BOTTOM, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, WD_FRAMETEXT_TOP, WD_INSET_LEFT, WD_INSET_RIGHT, NWidgetCore::widget_data, WWT_FRAME, and WWT_INSET.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp